<?php
//
//-------------------------------------------------------
//-- HANGMAN v2.0                                      --
//-- PHP game by Giovanni Crisci                       --
//-- http://giovi.supereva.it                          --
//-- Images taken from ASP code written by             --
//-- ASP101 http://www.asp101.com                      --
//-------------------------------------------------------
//
// main file
//

$showsol = false; //set it to true if you want to show the word after someone hangs himself

if (!eregi("mod.php", $PHP_SELF)) {
    die ("You can't access this file directly...");
}

require_once("mainfile.php");
$module_name = "hangman";

include("./mod/hangman/language/lang-english.php");

$pagetitle = "- $module_name";

// functions and variables
$alfabeto = array ('A' => 'a','B' => 'b','C' => 'c','D' => 'd','E' => 'e',
'F' => 'f','G' => 'g','H' => 'h','I' => 'i','J' => 'j','K' => 'k','L' => 'l',
'M' => 'm','N' => 'n','O' => 'o','P' => 'p','Q' => 'q','R' => 'r','S' => 's',
'T' => 't','U' => 'u','V' => 'v','W' => 'w','X' => 'x','Y' => 'y','Z' => 'z');
session_start ();

// choose a random word from the database

function ScegliParola () {
    global $table_prefix;
    $result = mysql_query("select max(id) from ".$table_prefix."mod_hangman");
    $numero_parole = mysql_fetch_row($result);
    $posizione_parola = rand (1, $numero_parole[0]);
    $result = mysql_query("select id, word from ".$table_prefix.'mod_hangman where id = '.$posizione_parola);
    $parola = mysql_fetch_row($result);
    return ($parola);
}

// check if the player can be added to the top list

function ControllaRecord ($wordid, $tempo, $tentativi) {
    global $table_prefix;
    $chk = array(false);
    $result =mysql_query("select * from ".$table_prefix."mod_hangman where id = ".$wordid);
    $riga = mysql_fetch_row($result);
    if ($tentativi<$riga[3] or ($tentativi==$riga[3] and $tempo<$riga[4]))
    $chk[0] = true;
    if ($riga[3]==6) $riga[2]='*nuovo**';
    $chk[1] = $riga[2];
    $chk[2] = $riga[3];
    $chk[3] = $riga[4];
    return $chk;
}

// read the actual best score

function CercaRecord ($wordid) {
    global $table_prefix;
    $result =mysql_query("select best, errors, time from ".$table_prefix."mod_hangman where id = ".$wordid);
    $riga = mysql_fetch_row($result);
    return $riga;
}

// changes all the unguessed letters with _

function CalcolaIndovinata ($parola, $escludi, $alfabeto) {
    $alfabeto = array_flip ($alfabeto);
    $escluse = strtr ($escludi, $alfabeto);
    $escluse = '['.$escluse.']';
    $escluse = ereg_replace ($escluse, '', '[ABCDEFGHIJKLMNOPQRSTUVWXYZ]');
    $indovinata = ereg_replace ($escluse, '_', $parola);
    return $indovinata;
}

// seeks the chosen letter in the word

function TrovaLettera ($lettera, $parola, $scelte, $alfabeto) {
    $alfabeto = array_flip ($alfabeto);
    $lettera = substr ($lettera, 0, 1);
    $lettera = strtr ($lettera, $alfabeto);
    $scelte.= $lettera;
    if (ereg ($lettera, $parola)) {
        $controllo = true;
    }
    else {
        $controllo = false;
    }
    $risposta = array ($scelte, $controllo);
    return $risposta;
}

// and this is the programme!

include("header.php");

?>

<p style="font-family:Arial, Helvetica,sans-serif;font-size:28px;font-weight:bold;color:black">
Hangman
</p>

<?php

// the word to be guessed has already been chosen

if (isset($_GET['letter']) and isset($_SESSION['gchangman'])) {
    $variab = explode ('/', $_SESSION['gchangman']);
    $indovina = $variab[0];
    $scelte = $variab[1];
    $tentativi = $variab[2];
    $checklet = TrovaLettera ($_GET['letter'], $indovina, $scelte, $alfabeto);
    $scelte = $checklet[0];
    if (!$checklet[1]) {
        $tentativi = $tentativi +1;
    }
    $indovinata = CalcolaIndovinata ($indovina, $scelte, $alfabeto);
}
else {

    // reset everything and choose a new word

    $tentativi=0;
    $scelte = ('_');
    $parola = ScegliParola ();
    $indovina = $parola[1];
    $_SESSION['gcid'] = $parola[0];
    $indovinata = CalcolaIndovinata ($indovina, $scelte, $alfabeto);
    $_SESSION['gctempo'] = time();
}

// set the cookie (or the get variable) via PHP sessions

$_SESSION['gchangman'] = ($indovina.'/'.$scelte.'/'.$tentativi);

if ($tentativi>6) $tentativi=6;

// print the word hiding the unfound letters

print ('<p><img src="./mod/hangman/images/hang_'.($tentativi+1).'.gif" style="border:0;width:100px;height:100px" alt="Miss '.$tentativi.'/6" /></p>');
echo ("\n<p>\n");
$caratteri = preg_split('//', $indovinata, -1, PREG_SPLIT_NO_EMPTY);
foreach ($caratteri as $lettalf) {
    $lettalf = strtr ($lettalf, $alfabeto);
    if ($lettalf==' ') {
        print (' <img src="./mod/hangman/images/lb_~.gif" style="border:0;width:20px;height:20px" alt="" />');
    }
    else {
        print (' <img src="./mod/hangman/images/lb_'.$lettalf.'.gif" style="border:0;width:20px;height:20px" alt="'.$lettalf.'" />');
    }
    echo ("\n");
    print (' <img src="./mod/hangman/images/lb_~.gif" style="border:0;width:20px;height:20px" alt="" />');
    echo ("\n");
}
print ('</p>');

// last part

if ($indovina!=$indovinata) {
    if ($tentativi>=6) {

        // ahi! hanged!

        print ('<p>'._HANGED);
        if ($showsol) print(' '._WORDWAS.' '.$indovina);
        $bestnow = CercaRecord ($_SESSION['gcid']);
        if ($bestnow[1]==6)
        print ('<br />'._GCHNONE.'</p>');
        else {
            if ($bestnow[0]=='') $bestnow[0]=_ANON;
            print ('<br />'.$bestnow[0].' '._GUESSEDIT.' '.$bestnow[2].' '._GCHSEC.' '.$bestnow[1].' '._CHANCES.'.</p>');
        }
    }
    else {

        // shows the full alphabet from which the letters can be chosen

        $scelt = preg_split('//', $scelte, -1, PREG_SPLIT_NO_EMPTY);
        echo ("\n<p>\n");
        foreach ($alfabeto as $lettalf) {
            $contrl = false;
            foreach ($scelt as $lett) {
                if (!strcasecmp ($lettalf, $lett)) {
                    $contrl = true;
                }
            }
            if ($contrl) {
                print (' <img src="./mod/hangman/images/lr_'.$lettalf.'.gif" style="border:0;width:20px;height:20px" alt="'.$lettalf.'" />');
            }
            else {
                print (' <a href="./mod.php?mod=hangman&name=Hangman&letter='.$lettalf.'"><img src="./mod/hangman/images/lb_'.$lettalf.'.gif" style="border:0;width:20px;height:20px" alt="'.$lettalf.'" /></a>');
            }
            if ($lettalf=='m') echo ("\n <br />");
            echo ("\n");
        }
        echo ("</p>\n");
    }
}
else {

    // the word has been guessed!

    echo ("\n<p>\n");
    print (_CONGRAT);
    $tempo = time() - $_SESSION['gctempo'];
    $oldbest = ControllaRecord ($_SESSION['gcid'], $tempo, $tentativi);
    if ($oldbest[1]=='') $oldbest[1]=_ANON2;
    if ($oldbest[0]) {

        // and there's a new record

        print ('<br />'._GUESST);
        if ($oldbest[1]!='*nuovo**') print (' '._BEAT.' '.$oldbest[1]);
        $result =mysql_query("update ".$table_prefix."mod_hangman set errors = "
        .$tentativi.", time = ".$tempo.
        " where id = ".$_SESSION['gcid']);

        // here is the form to insert own name

        ?>
        </p>
        <form method="post" action="./mod.php?mod=hangman&name=Hangman&op=insbest">
        <input type="hidden" name="wordid" value="<?=$_SESSION['gcid']; ?>" />
        <input type="hidden" name="besttime" value="<?=$tempo; ?>" />
        <input type="hidden" name="besttent" value="<?=$tentativi; ?>" />
        <p><?=_INSRT; ?><input type="text" name="newbest" size="15" maxlength="15" />
        <input type="submit" value="<?=_SBMT; ?>" name="go" /></p>
        </form>
        <?php
    }

    // word guessed, but someone did better

    else print('<br />'._SOMEBUT.' '.$oldbest[1].' '._GUESSEDIT.' '.$oldbest[3].' '._GCHSEC.' '.$oldbest[2].' '._CHANCES.'.</p>');
}

print ('<p><a href="./mod.php?mod=hangman&name=Hangman">'._NWGAME.'</a></p>');

include("footer.php");

?>